#ifndef __ATTRIBUTE_DEFS_H
#define	__ATTRIBUTE_DEFS_H

#include <iostream.h>
#include <String.h>
#include <assert.h>

class Attribute
{
	public :

		Attribute() { } ; 

		Attribute(const char* aName, const char* aValue) : name(aName), value(aValue) { } ;  

		Attribute(String& aName, String& aValue) : name(aName), value(aValue) { } ;  

		~Attribute() { } ;

		Attribute&
		operator = (const Attribute& anAttribute)
		{
			name = anAttribute.name ;  

			value = anAttribute.value ;  

			return *this ;
		}	
			
		int	
		operator == (const Attribute& anAttribute)
		{
			// cout << *this << " " << anAttribute << endl ;  
			return ( !compare(anAttribute.name,name) && 
				 value.contains(anAttribute.value) ) ? 1 : 0 ;  
		}

		int
		operator <= (const Attribute& anAttribute)
		{
			assert( !compare(anAttribute.name,name) ) ;

			return compare(value,anAttribute.value) ;
		}
				
		friend 
		ostream& operator << (ostream& os, const Attribute& anAttribute)
		{
			os << anAttribute.name << ":" << anAttribute.value ;	

			return os ;
		}

		String name ;

		String value ; 
} ;

#endif
