// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _AttributePtrSLList_h
#ifdef __GNUG__
#pragma interface
#endif
#define _AttributePtrSLList_h 1

#include <Pix.h>
#include "AttributePtr.defs.h"

#ifndef _AttributePtrSLListNode_h
#define _AttributePtrSLListNode_h 1

struct AttributePtrSLListNode
{
  AttributePtr                    hd;
  AttributePtrSLListNode*         tl;
                         AttributePtrSLListNode() { }
                         AttributePtrSLListNode(const AttributePtr  h, AttributePtrSLListNode* t = 0);
                         ~AttributePtrSLListNode() { }
};


inline AttributePtrSLListNode::AttributePtrSLListNode(const AttributePtr  h, AttributePtrSLListNode* t)
:hd(h), tl(t) {}

typedef AttributePtrSLListNode* AttributePtrSLListNodePtr;

#endif


class AttributePtrSLList
{
protected:
  AttributePtrSLListNode*        last;

public:
                        AttributePtrSLList();
                        AttributePtrSLList(const AttributePtrSLList& a);
                        ~AttributePtrSLList();

  AttributePtrSLList&   operator = (const AttributePtrSLList& a);

  int                   empty();
  int                   length();

  void                  clear();

  Pix                   prepend(AttributePtr  item);
  Pix                   append(AttributePtr  item);

  void                  join(AttributePtrSLList&);

  Pix                   prepend(AttributePtrSLListNode*);
  Pix                   append(AttributePtrSLListNode*);

  AttributePtr&                  operator () (Pix p);
  Pix                   first();
  void                  next(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, AttributePtr  item);
  void                  del_after(Pix p);

  AttributePtr&                  front();
  AttributePtr&                  rear();
  AttributePtr                   remove_front();
  int                   remove_front(AttributePtr& x);
  void                  del_front();

  void                  error(const char* msg);
  int                   OK();
};

inline AttributePtrSLList::~AttributePtrSLList()
{
  clear();
}

inline AttributePtrSLList::AttributePtrSLList()
{
  last = 0;
}

inline int AttributePtrSLList::empty()
{
  return last == 0;
}


inline Pix AttributePtrSLList::first()
{
  return (last == 0)? 0 : Pix(last->tl);
}

inline void AttributePtrSLList::next(Pix& p)
{
  p = (p == 0 || p == last)? 0 : Pix(((AttributePtrSLListNode*)(p))->tl);
}

inline AttributePtr& AttributePtrSLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((AttributePtrSLListNode*)(p))->hd;
}

inline AttributePtr& AttributePtrSLList::front()
{
  if (last == 0) error("front: empty list");
  return last->tl->hd;
}

inline AttributePtr& AttributePtrSLList::rear()
{
  if (last == 0) error("rear: empty list");
  return last->hd;
}

#endif
