// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../DLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _EdgePtrDLList_h
#ifdef __GNUG__
#pragma interface
#endif
#define _EdgePtrDLList_h 1

#include <Pix.h>
#include "EdgePtr.defs.h"

#ifndef _EdgePtrDLListNode_h
#define _EdgePtrDLListNode_h 1

struct EdgePtrDLListNode
{
  EdgePtr                    hd;
  EdgePtrDLListNode*         bk;
  EdgePtrDLListNode*         fd;
                         EdgePtrDLListNode();
                         EdgePtrDLListNode(const EdgePtr  h, 
                                       EdgePtrDLListNode* p = 0,
                                       EdgePtrDLListNode* n = 0);
                         ~EdgePtrDLListNode();
};

inline EdgePtrDLListNode::EdgePtrDLListNode() {}

inline EdgePtrDLListNode::EdgePtrDLListNode(const EdgePtr  h, EdgePtrDLListNode* p,
                                    EdgePtrDLListNode* n)
  :hd(h), bk(p), fd(n) {}

inline EdgePtrDLListNode::~EdgePtrDLListNode() {}

typedef EdgePtrDLListNode* EdgePtrDLListNodePtr;

#endif

class EdgePtrDLList
{
  friend class          EdgePtrDLListTrav;

  EdgePtrDLListNode*        h;

public:
                        EdgePtrDLList();
                        EdgePtrDLList(const EdgePtrDLList& a);
                        ~EdgePtrDLList();

  EdgePtrDLList&        operator = (const EdgePtrDLList& a);

  int                   empty();
  int                   length();

  void                  clear();

  Pix                   prepend(EdgePtr  item);
  Pix                   append(EdgePtr  item);
  void                  join(EdgePtrDLList&);

  EdgePtr&                  front();
  EdgePtr                   remove_front();
  void                  del_front();

  EdgePtr&                  rear();
  EdgePtr                   remove_rear();
  void                  del_rear();

  EdgePtr&                  operator () (Pix p);
  Pix                   first();
  Pix                   last();
  void                  next(Pix& p);
  void                  prev(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, EdgePtr  item);
  Pix                   ins_before(Pix p, EdgePtr  item);
  void                  del(Pix& p, int dir = 1);
  void                  del_after(Pix& p);

  void                  error(const char* msg);
  int                   OK();
};


inline EdgePtrDLList::~EdgePtrDLList()
{
  clear();
}

inline EdgePtrDLList::EdgePtrDLList()
{
  h = 0;
}

inline int EdgePtrDLList::empty()
{
  return h == 0;
}


inline void EdgePtrDLList::next(Pix& p)
{
  p = (p == 0 || p == h->bk)? 0 : Pix(((EdgePtrDLListNode*)p)->fd);
}

inline void EdgePtrDLList::prev(Pix& p)
{
  p = (p == 0 || p == h)? 0 : Pix(((EdgePtrDLListNode*)p)->bk);
}

inline Pix EdgePtrDLList::first()
{
  return Pix(h);
}

inline Pix EdgePtrDLList::last()
{
  return (h == 0)? 0 : Pix(h->bk);
}

inline EdgePtr& EdgePtrDLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((EdgePtrDLListNode*)p)->hd;
}

inline EdgePtr& EdgePtrDLList::front()
{
  if (h == 0) error("front: empty list");
  return h->hd;
}

inline EdgePtr& EdgePtrDLList::rear()
{
  if (h == 0) error("rear: empty list");
  return h->bk->hd;
}

#endif
