#include <iostream.h>
#include <Pix.h>
#include "Node.h"
#include "QueryTree.h"

AttributePtr
Node::SearchAttribute( Attribute& anAttribute )
{
	if ( attrList.empty() )
		return NULL ;


	for ( Pix i = attrList.first() ; i ; attrList.next(i) )
	{
		AttributePtr tmp = attrList(i) ;

		if ( *tmp == anAttribute )
			return tmp ;
	}

	return NULL ;
}

Node::~Node()
{
	delete queryTree ;
}

ostream&
operator << (ostream& os, Node& aNode) 
{
	if ( aNode.isLeaf() )
	{	
		os << "C " << aNode.name << " " ;
	}
	else 
	{	
		if ( aNode.name.empty() )
		{
			os << "I " << "(null) " ;
		}
		else
		{
			os << "I " << aNode.name << " " ;
		}

		os << aNode.selectivity << " " ; 
	}

	AttributePtr tmp = NULL ;

	os << "Attributes " << ' ' ;

	for ( Pix i = aNode.attrList.first() ; i ; 
				aNode.attrList.next(i) )
	{
		tmp = aNode.attrList(i) ;

		os << *tmp << " " ;
	}	
		
	if ( aNode.isLeaf() )
	{
		os << "Start Time " << aNode.startTime << " " ;

		os << "End Time " << aNode.endTime << " " ;
	}
	else
	{
		os << "Parents " << ' ' ;

		EdgePtr	etmp = NULL ; 

		for ( i = aNode.parentList.first() ; i ; 
				aNode.parentList.next(i) )
		{
			etmp = aNode.parentList(i) ;

			os << *etmp << " " ;
		}	

		os << "Children " << ' ' ;

		for ( i = aNode.childList.first() ; i ; 
				aNode.childList.next(i) )
		{
			etmp = aNode.childList(i) ;

			os << *etmp << " " ;
		}	
	}

	return os ;
}
