#ifndef __NODEPTR_DEFS_H
#define __NODEPTR_DEFS_H

#include "AttributePtr.SLList.h"
#include "EdgePtr.DLList.h"
#include "oper.h"

class	QueryTree ;

class Node
{
	public :

		Node() : oper(NOP),queryTree(NULL), selectivity(0) { } ;

		~Node() ; 

		String			name ;

		AttributePtrSLList	attrList ;

		EdgePtrDLList		childList ; 

		EdgePtrDLList		parentList ; 

		OperatorType		oper ;

		int			apply ; 

		QueryTree*		queryTree ; 	

		float			selectivity ;

		int			startTime ;

		int			endTime ; 

		int
		operator = (const Node& aNode)
		{
			return !compare(name,aNode.name) ? 1 : 0 ;  
		} ;

		int
		operator <= (const Node& aNode)
		{
			return compare(name,aNode.name) ;
		}

		int
		setNoApply()
		{
			apply = 0 ;
		}

		int
		setApply()
		{
			apply = 1 ;
		}

		int
		isApply()
		{
			return apply ;
		}	

		int
		setNoLeaf()
		{
			leafFlag =  0 ;
		}

		int
		setLeaf()
		{
			leafFlag = 1 ; 
		}

		int
		isLeaf()
		{
			return leafFlag ;
		}

		AttributePtr
		SearchAttribute( Attribute& anAttribute ) ; 

		AttributePtr
		SearchAttribute( String& attrName, String& attrValue ) 
		{
			return SearchAttribute( Attribute(attrName,attrValue) ) ; 
		}

		friend ostream&
		operator << (ostream& os, Node& aNode) ; 

	private :

		int leafFlag ; 

} ;

#endif
