// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../DLList.cc, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef __GNUG__
#pragma implementation
#endif
#include <limits.h>
#include <stream.h>
#include <builtin.h>
#include "NodePtr.DLList.h"

// error handling



void NodePtrDLList::error(const char* msg)
{
  (*lib_error_handler)("DLList", msg);
}

int NodePtrDLList::length()
{
  int l = 0;
  NodePtrDLListNode* t = h;
  if (t != 0) do { ++l; t = t->fd; } while (t != h);
  return l;
}

NodePtrDLList::NodePtrDLList(const NodePtrDLList& a)
{
  if (a.h == 0)
    h = 0;
  else
  {
    NodePtrDLListNode* p = a.h;
    NodePtrDLListNode* t = new NodePtrDLListNode(p->hd);
    h = t;
    p = p->fd;
    while (p != a.h)
    {
      NodePtrDLListNode* n = new NodePtrDLListNode(p->hd);
      t->fd = n;
      n->bk = t;
      t = n;
        p = p->fd;
    }
    t->fd = h;
    h->bk = t;
    return;
  }
}

NodePtrDLList& NodePtrDLList::operator = (const NodePtrDLList& a)
{
  if (h != a.h)
  {
    clear();
    if (a.h != 0)
    {
      NodePtrDLListNode* p = a.h;
      NodePtrDLListNode* t = new NodePtrDLListNode(p->hd);
      h = t;
      p = p->fd;
      while (p != a.h)
      {
        NodePtrDLListNode* n = new NodePtrDLListNode(p->hd);
        t->fd = n;
        n->bk = t;
        t = n;
        p = p->fd;
      }
      t->fd = h;
      h->bk = t;
    }
  }
  return *this;
}

void NodePtrDLList::clear()
{
  if (h == 0)
    return;

  NodePtrDLListNode* p = h->fd;
  h->fd = 0;
  h = 0;

  while (p != 0)
  {
    NodePtrDLListNode* nxt = p->fd;
    delete(p);
    p = nxt;
  }
}

void NodePtrDLList::print()
{
  if ( empty() )
    return ;

  for (Pix i=first();i;next(i)) 
  {
    NodePtr tmp = this->operator()(i);  
    cout << *tmp << endl ; 
  }
}

ostream& 
operator << (ostream& os,NodePtrDLList& aList)
{
  if ( aList.empty() )
    return os;
  
  os << aList.length() << endl ; 
  for (Pix i=aList.first();i;aList.next(i)) 
  {
    NodePtr tmp = aList(i);  
    if ( tmp->isLeaf() )
	os << tmp->startTime << "\t" << tmp->endTime << endl ; 
  }

  return os ; 
}



Pix NodePtrDLList::member(NodePtr item)
{
  for (Pix i=first();i;next(i)) 
  {
    NodePtr tmp = this->operator()(i);  
    if ( tmp == item ) 
      return i; 	 	
  }
  return 0;
}

NodePtr NodePtrDLList::retrieve(String& name)
{
  for (Pix i=first();i;next(i)) 
  {
    NodePtr tmp = this->operator()(i);  
    if ( tmp->name == name ) 
      return tmp; 	 	
  }
  return 0;
}
  
Pix NodePtrDLList::prepend(NodePtr  item)
{
  NodePtrDLListNode* t = new NodePtrDLListNode(item);
  if (h == 0)
    t->fd = t->bk = h = t;
  else
  {
    t->fd = h;
    t->bk = h->bk;
    h->bk->fd = t;
    h->bk = t;
    h = t;
  }
  return Pix(t);
}

Pix NodePtrDLList::append(NodePtr  item)
{
  NodePtrDLListNode* t = new NodePtrDLListNode(item);
  if (h == 0)
    t->fd = t->bk = h = t;
  else
  {
    t->bk = h->bk;
    t->bk->fd = t;
    t->fd = h;
    h->bk = t;
  }
  return Pix(t);
}

Pix NodePtrDLList::ins_after(Pix p, NodePtr  item)
{
  if (p == 0) return prepend(item);
  NodePtrDLListNode* u = (NodePtrDLListNode*) p;
  NodePtrDLListNode* t = new NodePtrDLListNode(item, u, u->fd);
  u->fd->bk = t;
  u->fd = t;
  return Pix(t);
}

Pix NodePtrDLList::ins_before(Pix p, NodePtr  item)
{
  if (p == 0) error("null Pix");
  NodePtrDLListNode* u = (NodePtrDLListNode*) p;
  NodePtrDLListNode* t = new NodePtrDLListNode(item, u->bk, u);
  u->bk->fd = t;
  u->bk = t;
  if (u == h) h = t;
  return Pix(t);
}

void NodePtrDLList::join(NodePtrDLList& b)
{
  NodePtrDLListNode* t = b.h;
  b.h = 0;
  if (h == 0)
    h = t;
  else if (t != 0)
  {
    NodePtrDLListNode* l = t->bk;
    h->bk->fd = t;
    t->bk = h->bk;
    h->bk = l;
    l->fd = h;
  }
}

void NodePtrDLList::join_unique(NodePtrDLList& b)
{
  for (Pix i=b.first();i;b.next(i))
  {
    NodePtr tmp = b(i);
    if (!member(tmp)) append(tmp); 
  }	
}

void NodePtrDLList::join_intersect(NodePtrDLList& b)
{
  Pix k = 0 ; 	
  for (Pix i=first();i;)
  {
    NodePtr tmp = this->operator()(i) ;
    if (!b.member(tmp))
    { 
      k = i; next(i) ;
      del(k); 
    }	
    else
      next(i) ; 
  }	
}

int NodePtrDLList::owns(Pix p)
{
  NodePtrDLListNode* t = h;
  if (t != 0 && p != 0)
  {
    do
    {
      if (Pix(t) == p) return 1;
      t = t->fd;
    } while (t != h);
  }
  return 0;
}

void NodePtrDLList::del(Pix& p, int dir)
{
  if (p == 0) error("null Pix");
  NodePtrDLListNode* t = (NodePtrDLListNode*) p;
  if (t->fd == t)
  {
    h = 0;
    p = 0;
  }
  else
  {
    if (dir < 0)
    {
      if (t == h)
        p = 0;
      else
        p = Pix(t->bk);
    }
    else
    {
      if (t == h->bk)
        p = 0;
      else
        p = Pix(t->fd);
    }
    t->bk->fd = t->fd;
    t->fd->bk = t->bk;
    if (t == h) h = t->fd;
  }
  delete t;
}

void NodePtrDLList::del_after(Pix& p)
{
  if (p == 0)
  {
    del_front();
    return;
  }

  NodePtrDLListNode* b = (NodePtrDLListNode*) p;
  NodePtrDLListNode* t = b->fd;

  if (b == t)
  {
    h = 0;
    p = 0;
  }
  else
  {
    t->bk->fd = t->fd;
    t->fd->bk = t->bk;
    if (t == h) h = t->fd;
  }
  delete t;
}

NodePtr NodePtrDLList::remove_front()
{
  if (h == 0)
    error("remove_front of empty list");
  NodePtrDLListNode* t = h;
  NodePtr res = t->hd;
  if (h->fd == h)
    h = 0;
  else
  {
    h->fd->bk = h->bk;
    h->bk->fd = h->fd;
    h = h->fd;
  }
  delete t;
  return res;
}


void NodePtrDLList::del_front()
{
  if (h == 0)
    error("del_front of empty list");
  NodePtrDLListNode* t = h;
  if (h->fd == h)
    h = 0;
  else
  {
    h->fd->bk = h->bk;
    h->bk->fd = h->fd;
    h = h->fd;
  }
  delete t;
}

NodePtr NodePtrDLList::remove_rear()
{
  if (h == 0)
    error("remove_rear of empty list");
  NodePtrDLListNode* t = h->bk;
  NodePtr res = t->hd;
  if (h->fd == h)
    h = 0;
  else
  {
    t->fd->bk = t->bk;
    t->bk->fd = t->fd;
  }
  delete t;
  return res;
}


void NodePtrDLList::del_rear()
{
  if (h == 0)
    error("del_rear of empty list");
  NodePtrDLListNode* t = h->bk;
  if (h->fd == h)
    h = 0;
  else
  {
    t->fd->bk = t->bk;
    t->bk->fd = t->fd;
  }
  delete t;
}


int NodePtrDLList::OK()
{
  int v = 1;
  if (h != 0)
  {
    NodePtrDLListNode* t = h;
    long count = LONG_MAX;      // Lots of chances to find h!
    do
    {
      count--;
      v &= t->bk->fd == t;
      v &= t->fd->bk == t;
      t = t->fd;
    } while (v && count > 0 && t != h);
    v &= count > 0;
  }
  if (!v) error("invariant failure");
  return v;
}
