// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../DLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _NodePtrDLList_h
#ifdef __GNUG__
#pragma interface
#endif
#define _NodePtrDLList_h 1

#include <Pix.h>
#include "NodePtr.defs.h"

#ifndef _NodePtrDLListNode_h
#define _NodePtrDLListNode_h 1

struct NodePtrDLListNode
{
  NodePtr                    hd;
  NodePtrDLListNode*         bk;
  NodePtrDLListNode*         fd;
                         NodePtrDLListNode();
                         NodePtrDLListNode(const NodePtr  h, 
                                       NodePtrDLListNode* p = 0,
                                       NodePtrDLListNode* n = 0);
                         ~NodePtrDLListNode();
};

inline NodePtrDLListNode::NodePtrDLListNode() {}

inline NodePtrDLListNode::NodePtrDLListNode(const NodePtr  h, NodePtrDLListNode* p,
                                    NodePtrDLListNode* n)
  :hd(h), bk(p), fd(n) {}

inline NodePtrDLListNode::~NodePtrDLListNode() {}

typedef NodePtrDLListNode* NodePtrDLListNodePtr;

#endif

class NodePtrDLList
{
  friend class          NodePtrDLListTrav;

  NodePtrDLListNode*        h;

  int			queryListFlag ; 

public:
                        NodePtrDLList();
                        NodePtrDLList(const NodePtrDLList& a);
                        ~NodePtrDLList();

  NodePtrDLList&        operator = (const NodePtrDLList& a);
  friend 
  ostream&		operator << (ostream& os,NodePtrDLList& a);

  int                   empty();
  int                   length();

  void                  clear();
  void			print(); 

  Pix                   prepend(NodePtr  item);
  Pix                   append(NodePtr  item);
  void                  join(NodePtrDLList&);
  void			join_unique(NodePtrDLList&) ; // Pointer comparisions
  void			join_intersect(NodePtrDLList&) ; // Pointer comparisions
  void			setQueryList() 	 { queryListFlag = 1; } ;
  void			setNoQueryList() { queryListFlag = 0; } ; 
  int			isQueryList() { return queryListFlag ; } ; 

  Pix			member(NodePtr item) ; // Pointer comparisions
  NodePtr		retrieve(String& nodeName) ; 

  NodePtr&              front();
  NodePtr               remove_front();
  void                  del_front();

  NodePtr&              rear();
  NodePtr               remove_rear();
  void                  del_rear();

  NodePtr&              operator () (Pix p);
  Pix                   first();
  Pix                   last();
  void                  next(Pix& p);
  void                  prev(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, NodePtr  item);
  Pix                   ins_before(Pix p, NodePtr  item);
  void                  del(Pix& p, int dir = 1);
  void                  del_after(Pix& p);

  void                  error(const char* msg);
  int                   OK();
};


inline NodePtrDLList::~NodePtrDLList()
{
  clear();
}

inline NodePtrDLList::NodePtrDLList()
{
  h = 0; queryListFlag = 0 ; 
}

inline int NodePtrDLList::empty()
{
  return h == 0;
}


inline void NodePtrDLList::next(Pix& p)
{
  p = (p == 0 || p == h->bk)? 0 : Pix(((NodePtrDLListNode*)p)->fd);
}

inline void NodePtrDLList::prev(Pix& p)
{
  p = (p == 0 || p == h)? 0 : Pix(((NodePtrDLListNode*)p)->bk);
}

inline Pix NodePtrDLList::first()
{
  return Pix(h);
}

inline Pix NodePtrDLList::last()
{
  return (h == 0)? 0 : Pix(h->bk);
}

inline NodePtr& NodePtrDLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((NodePtrDLListNode*)p)->hd;
}

inline NodePtr& NodePtrDLList::front()
{
  if (h == 0) error("front: empty list");
  return h->hd;
}

inline NodePtr& NodePtrDLList::rear()
{
  if (h == 0) error("rear: empty list");
  return h->bk->hd;
}

#endif
