// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _StringNodePtrDLListPtrAVLMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _StringNodePtrDLListPtrAVLMap_h 1

#include "String.NodePtrDLListPtr.Map.h"

struct StringNodePtrDLListPtrAVLNode
{
  String                 	      item;
  NodePtrDLListPtr                    cont;
  StringNodePtrDLListPtrAVLNode*      lt;
  StringNodePtrDLListPtrAVLNode*      rt;
  char                		      stat;
                      StringNodePtrDLListPtrAVLNode(String& h, NodePtrDLListPtr  c, 
                                    StringNodePtrDLListPtrAVLNode* l=0, StringNodePtrDLListPtrAVLNode* r=0);
                      ~StringNodePtrDLListPtrAVLNode();
};

inline StringNodePtrDLListPtrAVLNode::StringNodePtrDLListPtrAVLNode(String& h, NodePtrDLListPtr  c, 
                                    StringNodePtrDLListPtrAVLNode* l, StringNodePtrDLListPtrAVLNode* r)
     :item(h), cont(c), lt(l), rt(r), stat(0) {}

inline StringNodePtrDLListPtrAVLNode::~StringNodePtrDLListPtrAVLNode() {}

typedef StringNodePtrDLListPtrAVLNode* StringNodePtrDLListPtrAVLNodePtr;


class StringNodePtrDLListPtrAVLMap : public StringNodePtrDLListPtrMap
{
protected:
  StringNodePtrDLListPtrAVLNode*   root;

  StringNodePtrDLListPtrAVLNode*   leftmost();
  StringNodePtrDLListPtrAVLNode*   rightmost();
  StringNodePtrDLListPtrAVLNode*   pred(StringNodePtrDLListPtrAVLNode* t);
  StringNodePtrDLListPtrAVLNode*   succ(StringNodePtrDLListPtrAVLNode* t);
  void            _kill(StringNodePtrDLListPtrAVLNode* t);
  void            _add(StringNodePtrDLListPtrAVLNode*& t);
  void            _del(StringNodePtrDLListPtrAVLNode* p, StringNodePtrDLListPtrAVLNode*& t);

public:
                StringNodePtrDLListPtrAVLMap(NodePtrDLListPtr  dflt);
                StringNodePtrDLListPtrAVLMap(StringNodePtrDLListPtrAVLMap& a);
                ~StringNodePtrDLListPtrAVLMap();

  NodePtrDLListPtr&          operator [] (String& key);

  void          del(String& key);

  Pix           first();
  void          next(Pix& i);
  String&          key(Pix i);
  NodePtrDLListPtr&          contents(Pix i);

  Pix           seek(String& key);
  int           contains(String& key);

  void          clear(); 

  Pix           last();
  void          prev(Pix& i);

  int           OK();
};

inline StringNodePtrDLListPtrAVLMap::~StringNodePtrDLListPtrAVLMap()
{
  _kill(root);
}

inline StringNodePtrDLListPtrAVLMap::StringNodePtrDLListPtrAVLMap(NodePtrDLListPtr  dflt) :StringNodePtrDLListPtrMap(dflt)
{
  root = 0;
}

inline Pix StringNodePtrDLListPtrAVLMap::first()
{
  return Pix(leftmost());
}

inline Pix StringNodePtrDLListPtrAVLMap::last()
{
  return Pix(rightmost());
}

inline void StringNodePtrDLListPtrAVLMap::next(Pix& i)
{
  if (i != 0) i = Pix(succ((StringNodePtrDLListPtrAVLNode*)i));
}

inline void StringNodePtrDLListPtrAVLMap::prev(Pix& i)
{
  if (i != 0) i = Pix(pred((StringNodePtrDLListPtrAVLNode*)i));
}

inline String& StringNodePtrDLListPtrAVLMap::key(Pix i)
{
  if (i == 0) error("null Pix");
  return ((StringNodePtrDLListPtrAVLNode*)i)->item;
}

inline NodePtrDLListPtr& StringNodePtrDLListPtrAVLMap::contents(Pix i)
{
  if (i == 0) error("null Pix");
  return ((StringNodePtrDLListPtrAVLNode*)i)->cont;
}

inline void StringNodePtrDLListPtrAVLMap::clear()
{
  _kill(root);
  count = 0;
  root = 0;
}

inline int StringNodePtrDLListPtrAVLMap::contains(String& key)
{
  return seek(key) != 0;
}

#endif
