#ifndef __TREENODE_H
#define	__TREENODE_H

#include <String.h>
#include "oper.h"

struct LeafInfo
{
	String	attrName ;
	String	attrValue ;
} ;

struct TreeNode
{
	TreeNode() : left(0), right(0) 
	{} ; 

	int
	operator == ( TreeNode& aTreeNode ) ;

	void
	setLeaf() { flag = 1 ; } ;

	void
	setNoLeaf() { flag = 0 ; } ; 

	int
	isLeaf() { return flag ; } ; 

	LeafInfo	info ;	// if leaf node
	OperatorType	oper ;	// if intermediate node

	int		left ;	
	int		right ; 

	String		nodeNum ; // Has been put as string in order 
				  // to aid the parser.

	private :
		int flag ;
} ; 

inline int
TreeNode::operator == ( TreeNode& aTreeNode )
{
	if ( isLeaf() && aTreeNode.isLeaf() )
	{
		if ( info.attrName == aTreeNode.info.attrName &&
		     info.attrValue == aTreeNode.info.attrValue )
			return 1 ;
	}
	else if ( !isLeaf() && !aTreeNode.isLeaf() )  
	{
		if ( oper == aTreeNode.oper )
			return 1 ; 
	}

	return 0 ; 
}

#endif
