// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _TreeNodePtrSLList_h
#ifdef __GNUG__
#pragma interface
#endif
#define _TreeNodePtrSLList_h 1

#include <Pix.h>
#include "TreeNodePtr.defs.h"

#ifndef _TreeNodePtrSLListNode_h
#define _TreeNodePtrSLListNode_h 1

struct TreeNodePtrSLListNode
{
  TreeNodePtr                    hd;
  TreeNodePtrSLListNode*         tl;
                         TreeNodePtrSLListNode() { }
                         TreeNodePtrSLListNode(const TreeNodePtr  h, TreeNodePtrSLListNode* t = 0);
                         ~TreeNodePtrSLListNode() { }
};


inline TreeNodePtrSLListNode::TreeNodePtrSLListNode(const TreeNodePtr  h, TreeNodePtrSLListNode* t)
:hd(h), tl(t) {}

typedef TreeNodePtrSLListNode* TreeNodePtrSLListNodePtr;

#endif


class TreeNodePtrSLList
{
protected:
  TreeNodePtrSLListNode*        last;

public:
                        TreeNodePtrSLList();
                        TreeNodePtrSLList(const TreeNodePtrSLList& a);
                        ~TreeNodePtrSLList();

  TreeNodePtrSLList&            operator = (const TreeNodePtrSLList& a);

  int                   empty();
  int                   length();

  void                  clear();

  Pix                   prepend(TreeNodePtr  item);
  Pix                   append(TreeNodePtr  item);

  Pix			elem(int) ;  
  void                  join(TreeNodePtrSLList&);

  Pix                   prepend(TreeNodePtrSLListNode*);
  Pix                   append(TreeNodePtrSLListNode*);

  TreeNodePtr&                  operator () (Pix p);
  Pix                   first();
  void                  next(Pix& p);
  int                   owns(Pix p);
  Pix                   ins_after(Pix p, TreeNodePtr  item);
  void                  del_after(Pix p);

  TreeNodePtr&                  front();
  TreeNodePtr&                  rear();
  TreeNodePtr                   remove_front();
  int                   remove_front(TreeNodePtr& x);
  void                  del_front();

  void                  error(const char* msg);
  int                   OK();
};

inline TreeNodePtrSLList::~TreeNodePtrSLList()
{
  clear();
}

inline TreeNodePtrSLList::TreeNodePtrSLList()
{
  last = 0;
}

inline int TreeNodePtrSLList::empty()
{
  return last == 0;
}


inline Pix TreeNodePtrSLList::first()
{
  return (last == 0)? 0 : Pix(last->tl);
}

inline void TreeNodePtrSLList::next(Pix& p)
{
  p = (p == 0 || p == last)? 0 : Pix(((TreeNodePtrSLListNode*)(p))->tl);
}

inline TreeNodePtr& TreeNodePtrSLList::operator () (Pix p)
{
  if (p == 0) error("null Pix");
  return ((TreeNodePtrSLListNode*)(p))->hd;
}

inline TreeNodePtr& TreeNodePtrSLList::front()
{
  if (last == 0) error("front: empty list");
  return last->tl->hd;
}

inline TreeNodePtr& TreeNodePtrSLList::rear()
{
  if (last == 0) error("rear: empty list");
  return last->hd;
}

#endif
